import React, { useState, useEffect } from 'react';
import { Form, Input, Button, Switch, Icon, Select, Option, message, Table, Divider, Tag, Pagination, Modal, DatePicker, Row, Col } from 'antd';
import router from 'umi/router';
import moment from 'moment';
import AuthButton from '@/components/AuthButton';
import BuildSelect from '@/components/SelectButton/BuildSelect2'
import ChannelSelect from '@/components/SelectButton/channelSelect'
import QrcodeType from '../../../components/SelectButton/QrcodeType'
import QrText from './components/qrText'
import apis from '../../../services/apis';
import request from '../../../utils/request';



const header = props => {

    // const id = props.location.query.id

    const [data, setData] = useState({})

    const [visible, setVisible] = useState(true)

    const [targetType, setTargetType] = useState()

    const [buildingId, setBuildingId] = useState()

    const [targetName, setTargetName] = useState()

    useEffect(() => {

    }, [])

    function addQrcode(params) {
        request({ ...apis.qrcode.add, data: { ...params } }).then((data) => {
            //   setData(data)
            router.go(-1)
        }).catch((err) => {
            console.log(err)
            message.info(err.msg || err.message)
        })
    }

    function handleSubmit(e) {
        e.preventDefault();
        props.form.validateFields((err, values) => {
            if (!err) {
                console.log(values)
                if (targetType === 'project') {
                    values.targetId = values.buildingId
                    values.targetName = targetName
                }else{
                    values.targetId = values.targetName.id
                    values.targetName = values.targetName.name
                }
                addQrcode(values)
            }
        },
        )
    }

    // switch
    function onChange(checked) {
        console.log(`switch to ${checked}`);
        setVisible(checked)
    }

    // QrcodeType
    function onTtypeChange(values) {
        console.log(`onTtypeChange to ${values}`);
        setTargetType(values)
        // props.form.setFields({
        //     targetiId: values.id,
        // })
    }

    // BuildingChange
    function onBuildingChange(values, data) {
        console.log(`onBuildingChange to ${values}`, data);
        setBuildingId(values)
        setTargetName(data.buildingName)
    }

    // BuildingChange
    function onTargetName(values, data) {
        console.log(`onTargetName to ${values}`, data);

    }


    const { getFieldDecorator } = props.form

    return (

        <>
            <Form labelCol={{ span: 8 }} wrapperCol={{ span: 12 }} onSubmit={handleSubmit}>
                <Form.Item label="是否关联项目">
                    {getFieldDecorator('a', {
                        initialValue: true,
                        rules: [{ required: true, message: '' }],
                    })(<Switch onChange={onChange} defaultChecked />)}
                </Form.Item>
                {visible && <Form.Item label="关联项目">
                    {getFieldDecorator('buildingId', {
                        rules: [{ required: true, message: '' }],
                    })(<BuildSelect onChange={onBuildingChange} />)}
                </Form.Item>}
                <Form.Item label="二维码内容类型">
                    {getFieldDecorator('targetType', {
                        rules: [{ required: true, message: '' }],
                    })(<QrcodeType visible={visible} onChange={onTtypeChange}></QrcodeType>)}
                </Form.Item>
                {targetType !== 'project' && <Form.Item label="二维码内容">
                    {getFieldDecorator('targetName', {
                        rules: [{ required: true, message: '' }],
                    })(<QrText targetType={targetType} buildingId={buildingId} onChange={onTargetName}/>)}
                </Form.Item>}
                {targetType === 'project' && <div>
                    {getFieldDecorator('targetName')}
                </div>}
                <Form.Item label="是否关联项目">
                    {getFieldDecorator('channelId')(
                        <ChannelSelect />,
                    )}
                </Form.Item>

                <Form.Item wrapperCol={{ span: 15, offset: 8 }}>
                    <div style={{ width: '190px' }}>
                        <Button type="primary" style={{ marginRight: '20px' }} htmlType="submit">立即生成</Button>
                        <Button onClick={() => router.go(-1)} htmlType="submit">取消</Button>
                    </div>
                </Form.Item>
            </Form>

        </>
    )
}



const WrappedNormalLoginForm = Form.create({ name: 'header' })(header);
export default WrappedNormalLoginForm